<template>
  <el-select
    v-model="selected"
    class="print-plan-select"
    :placeholder="placeholder"
    filterable
    :multiple="multiple"
    :clearable="clearable"
    :disabled="disabled"
    @change="select"
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :value="item.id"
      :label="item.name"
    >
    </el-option>
  </el-select>
</template>

<script>
import { conditionListPrintPlan } from "../../modules/base/api";
import { objFilterNull } from "../../plugins/utils";

export default {
  name: "print-plan-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "请选择" },
    value: { type: [Number, String, Array], default: "" },
    clearable: { type: Boolean, default: true },
    multiple: { type: Boolean, default: false },
    semesterId: { type: String, default: "" },
    examId: { type: String, default: "" },
  },
  data() {
    return {
      optionList: [],
      selected: "",
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      },
    },
    semesterId(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
    examId(val, oldval) {
      if (val !== oldval) {
        this.search();
        this.$emit("input", "");
        this.$emit("change", {});
      }
    },
  },
  async created() {
    this.search();
  },
  methods: {
    async search() {
      let data = {
        semesterId: this.semesterId,
        examId: this.examId,
      };
      const res = await conditionListPrintPlan(objFilterNull(data));
      this.optionList = res;
    },
    select() {
      this.$emit("input", this.selected);

      if (this.multiple) {
        this.$emit(
          "change",
          this.optionList.filter((item) => this.selected.includes(item.id))
        );
      } else {
        this.$emit(
          "change",
          this.optionList.find((item) => item.id === this.selected)
        );
      }
    },
  },
};
</script>
